package logic

import (
	"context"
	"errors"

	"juwan-backend/app/community/rpc/internal/models/postlikes"
	"juwan-backend/app/community/rpc/internal/svc"
	"juwan-backend/app/community/rpc/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdatePostLikesLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUpdatePostLikesLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdatePostLikesLogic {
	return &UpdatePostLikesLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *UpdatePostLikesLogic) UpdatePostLikes(in *pb.UpdatePostLikesReq) (*pb.UpdatePostLikesResp, error) {
	if in.PostId == nil || in.UserId == nil {
		return nil, errors.New("postId and userId are required")
	}

	_, err := l.svcCtx.CommunityModelRO.PostLikes.Query().
		Where(postlikes.PostIDEQ(in.GetPostId()), postlikes.UserIDEQ(in.GetUserId())).
		First(l.ctx)
	if err != nil {
		return nil, errors.New("post like not found")
	}

	_, err = l.svcCtx.CommunityModelRW.PostLikes.Update().
		Where(postlikes.PostIDEQ(in.GetPostId()), postlikes.UserIDEQ(in.GetUserId())).
		Save(l.ctx)
	if err != nil {
		logx.Errorf("updatePostLikes err: %v", err)
		return nil, errors.New("update post like failed")
	}

	return &pb.UpdatePostLikesResp{}, nil
}
